import { makeGet } from "$lib/tools/requests/requests";
import { isPast, parseISO } from "date-fns";
import { jwtDecode } from "jwt-decode";

const LocalStorageItemName =
  "99e546e033b0de65338b3410d5d779bfae88d513dd1238190b26a509";

export function saveAuthInfo(jwt) {
  localStorage.setItem(LocalStorageItemName, JSON.stringify({ a: jwt }));
}

export function getAuthInfo() {
  return localStorage.getItem(LocalStorageItemName)
    ? JSON.parse(localStorage.getItem(LocalStorageItemName))
    : null;
}

export async function checkAuth() {
  let item = getAuthInfo();
  if (!item) return false;
  if (!item.a) return false;
  const result = await makeGet("rate", makeAuthHeaderForAxios(item.a));
  if (result.error) return false;
  return true;
}

export function checkAuthSync() {
  let result = getAuthInfo();
  // console.log('+');
  if (!result) return false;
  // console.log('-');
  try {
    let decoded = jwtDecode(result.a);
    // console.log('жопа');
    return !isPast(parseISO(new Date(decoded.exp * 1000).toISOString()));
  } catch (e) {
    // console.log('хуй');
    return false;
  }
}

export const makeAuthHeaderForAxios = (jwt) => {
  return {
    headers: {
      Authorization: "Bearer " + jwt,
      "Content-Type": "application/json",
    },
  };
};
