import { browser } from "$app/environment";
import { getAuthInfo, makeAuthHeaderForAxios } from "$lib/auth/Auth";
import { makePost } from "$lib/tools/requests/requests";
import { sayError } from "$lib/tools/toaster/Toaster";
import { redirect } from "$lib/tools/url/URLTools";

export async function load({ params }) {
  if (!browser) return;
  const { userToken } = params;
  const userResult = await makePost(
    "getUser",
    {
      token: userToken,
    },
    makeAuthHeaderForAxios(getAuthInfo()?.a)
  );
  if (userResult.status === 401) {
    sayError("Данные авторизации устарели");
    // window.location.href = "/";
    redirect("/admin/");
    return { };
  }
  if (userResult.error) {
    sayError("Не удалось настроить пользователя");
    return {};
  }
  return {
    token: userToken,
    userData: userResult.data,
  };
}
